package ttt.isatm.model;

public class TTTGameLogic {
	//String[][] boardArray = new String[3][3];
	
	// a map of the board
	String[][] boardArray = {
			{"*","*","*"},
			{"*","*","*"},
			{"*","*","*"}
	};

	// member variables holding players' info
	TTTPlayer player1;
	TTTPlayer player2;


	public TTTGameLogic(TTTPlayer player1, TTTPlayer player2) {
		this.player1 = player1;
		this.player2 = player2;
	}

	// get the current playing entity
	public TTTPlayer getCurrentPlayer() {
		TTTPlayer currentPlayer = null;

		if(player1.isCurrent()) {
			currentPlayer = player1;
		} 

		if(player2.isCurrent()) {
			currentPlayer = player2;
		}
		
		return currentPlayer;
	}
	
	// get the next playing entity
	public TTTPlayer getNextPlayer() {
		TTTPlayer currentPlayer = null;

		if(player1.isCurrent()) {
			currentPlayer = player2;
		} 

		if(player2.isCurrent()) {
			currentPlayer = player1;
		}
		
		return currentPlayer;
	}

	// update players' turns 
	public void setCurrentPlayer() {
		
		if(player1.isCurrent()) {
			player1.setCurrent(false);
			player2.setCurrent(true);
		} else {
			player1.setCurrent(true);
			player2.setCurrent(false);
		}
	}
	
	// get winning player
	public TTTPlayer getWinner() {
		if(player1.isWinner())
			return player1;
		if(player2.isWinner())
			return player2;

		return null;
	}

	// apply game move logic
	public void move(int x, int y) {
		TTTPlayer currentPlayer = getCurrentPlayer();

		applyMove(x,y,currentPlayer.getMarker());
		if(isWinnerMove())
			currentPlayer.setWinner(true);

	}

	private void applyMove(int x, int y, String marker) {
		boardArray[x][y] = marker;		
	}

	// check if a move is a winning move
	private boolean isWinnerMove() {

		return verifyLines() || verifyColumns() || verifyDiagonals();
	}

	private boolean verifyLines() {

		for(int i=0;i<3;i++) {
			int counter = 0;
			for(int j=1;j<3;j++) {
				if(boardArray[i][0].equals("*")) break;
				if(!boardArray[i][j].equals(boardArray[i][0]))
					break;
				counter++;
			}

			if(counter == 2) {
				return true;
			}
		}

		return false;
	}

	private boolean verifyColumns() {
		for(int i=0;i<3;i++) {
			int counter = 0;
			for(int j=1;j<3;j++) {				
				if(boardArray[0][i].equals("*")) break;
				if(!boardArray[j][i].equals(boardArray[0][i])) 
					break;				
				counter++;
			}

			if(counter == 2) {
				return true;
			}
		}

		return false;
	}

	private boolean verifyDiagonals() {
			int counterFstDiag = 0;
			int counterScndDiag = 0;
			
			for(int j=1;j<3;j++) {
				System.out.println(boardArray[0][0] + " <> " + boardArray[j][j]);
				
				
				if(boardArray[0][0].equals(boardArray[j][j])) 
					counterFstDiag++;
				
				System.out.println(boardArray[0][2] + " <> " + boardArray[j][2-j]);
				
				if(boardArray[0][2].equals(boardArray[j][2-j])) 
					counterScndDiag++;				
			}

			if((counterFstDiag == 2 && !boardArray[0][0].equals("*")) 
					|| 
				(counterScndDiag == 2 && !boardArray[0][2].equals("*"))) {
				return true;
			} 
		
		return false;
	}

	// test game logic independent from the controller or view
	public static void main(String[] args) {
		TTTGameLogic gl = new TTTGameLogic(null, null);
		System.out.println(gl.isWinnerMove());
	}

}
