package ttt.isatm.view.gui;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.HashMap;

import javax.swing.JPanel;

import ttt.isatm.view.MainUIFrameListener;
import ttt.isatm.view.gui.custom.TTTBoardCellJLabel;

/*
 * Panel holding the gameboard;
 */
public class GameBoardJPanel extends JPanel {


	HashMap<TTTBoardCellJLabel, Point> cells;
	MainUIFrameListener mainFrameListener;
	ChangeListener changeListener;

	public GameBoardJPanel() {
		super();
		// TODO Auto-generated constructor stubs
		setBackground(new Color(100,100,100)); 

		initLayout();
		initWidgets();
	}

	private void initLayout() {
		setLayout(new GridLayout(3, 3));
	}

	private void initWidgets() {
		// create a 3x3 grid layout in order to simulate the cells of the gameboard

		cells = new HashMap<TTTBoardCellJLabel, Point>();

		for(int i=0;i<3;i++) 
			for(int j=0; j<3;j++) {
				TTTBoardCellJLabel cell = new TTTBoardCellJLabel("*");

				cells.put(cell, new Point(i,j));
				add(cell);

				createListener(cell);
			}
	}

	public void addMainUIFrameListener(MainUIFrameListener l) {
		mainFrameListener = l;
	}

	public void addChangeListener(ChangeListener cl) {
		changeListener = cl;
	}

	private void createListener(final TTTBoardCellJLabel cell) {
		cell.addMouseListener(new MouseListener() {

			@Override
			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void mousePressed(MouseEvent e) {
				// TODO Auto-generated method stub
				if(!cell.isClicked()) {
					changeListener.playerTurnChange();
					cell.setText(mainFrameListener.getCurrentMarker());
					cell.setClicked();
					mainFrameListener.notifyMove(cells.get(cell));
				}
			}

			@Override
			public void mouseExited(MouseEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void mouseEntered(MouseEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void mouseClicked(MouseEvent e) {
				// TODO Auto-generated method stub
			}
		});
	}
}
