package ttt.isatm.view.gui;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;

import ttt.isatm.view.MainUIFrameListener;
import ttt.isatm.view.gui.custom.TTTJButton;
import ttt.isatm.view.gui.custom.TTTJLabel;
import ttt.isatm.view.gui.custom.TTTJTextField;


public class GameStartUpJPanel extends JPanel {
	// two player game: we will use two labes and two text fields 
	// for this games startup form. Mockup:
	// Player 1 name:
	// [ text field  ]
	// Player 2 name:
	// [ text field ]
	
	MainUIFrameListener mainFrameListener;
	
	public GameStartUpJPanel(MainUIFrameListener listener) {
		super();
		setBackground(new Color(100,100,100));
		
		initWidgets();		
		mainFrameListener = listener;
	}
	
	private void initWidgets() {
		
		// create widgets
		TTTJLabel player1 = new TTTJLabel("Player 1's name: ");
		TTTJLabel player2 = new TTTJLabel("Player 2's name: ");
		player1.setAlignmentX(CENTER_ALIGNMENT);
		player2.setAlignmentX(CENTER_ALIGNMENT);
		
		// the names need to be final in order to be visible in the MouseListener anonymous class below
		final TTTJTextField name1 = new TTTJTextField("Player #1");
		name1.setMaximumSize(new Dimension(300,25));

		final TTTJTextField name2 = new TTTJTextField("Player #2");
		name2.setMaximumSize(new Dimension(300,25));

		//TTTBoardCellJLabel startButton = new TTTBoardCellJLabel("*");
		TTTJButton startButton = new TTTJButton("START");
		startButton.setAlignmentX(CENTER_ALIGNMENT);		
		
		// set a layout manager
		setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
		
		// add widgets to panel
		Box horizontalBox = Box.createHorizontalBox();
		horizontalBox.add(Box.createHorizontalGlue());		
		Box playerBox = Box.createVerticalBox();
		playerBox.setAlignmentX(CENTER_ALIGNMENT);
		playerBox.add(player1);		
		playerBox.add(name1);
		playerBox.add(Box.createRigidArea(new Dimension(5,5)));
		playerBox.add(player2);		
		playerBox.add(name2);
		playerBox.add(Box.createRigidArea(new Dimension(5,5)));
		playerBox.add(startButton);
		horizontalBox.add(playerBox);				
		horizontalBox.add(Box.createHorizontalGlue());
		
		Box verticalBox = Box.createVerticalBox();
		verticalBox.add(Box.createVerticalGlue());
		verticalBox.add(horizontalBox);
		verticalBox.add(Box.createVerticalGlue());

		
		add(verticalBox);	
		
		// add actions to the start button
		startButton.addMouseListener(new MouseListener() {
			
			@Override
			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mousePressed(MouseEvent e) {
				// TODO Auto-generated method stub
				// 1. check that both players entered their names
				
				// 2. announce the start to the mainUIframe
				mainFrameListener.initPlayers(name1.getText(), name2.getText());
			}
			
			@Override
			public void mouseExited(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mouseEntered(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mouseClicked(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
		});
	}
}
