package ttt.isatm.view.gui;
import java.awt.Color;
import java.awt.Dimension;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;

import ttt.isatm.view.gui.custom.TTTJLabel;

/*
 * Psnrl displaying player info during the game (turn, marker, player's name)
 */
public class InfoJPanel extends JPanel implements ChangeListener {

	TTTJLabel player1Info;
	TTTJLabel player2Info;
	int turn = 0;
	static Color basicColor;
	
	public InfoJPanel(String player1, String player2) {
		super();
		// TODO Auto-generated constructor stub
		setBackground(new Color(100,100,100)); 
		
		initLayout();
		initWidgets(player1, player2);
	}
	
	private void initLayout() {
		setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));		
	}
	
	private void initWidgets(String player1, String player2) {
		player1Info = new TTTJLabel(player1/*some info (e.g. name)*/);
		player2Info = new TTTJLabel(player2/*some info (e.g. name)*/);
		basicColor = player1Info.getForeground();
		
		Box horizontalBox = Box.createHorizontalBox();
		horizontalBox.add(Box.createHorizontalGlue());		
		Box playerBox = Box.createVerticalBox();
		playerBox.setAlignmentX(CENTER_ALIGNMENT);
		playerBox.add(player1Info);		
		
		playerBox.add(Box.createRigidArea(new Dimension(5,5)));
		playerBox.add(player2Info);		
					
		horizontalBox.add(playerBox);				
		horizontalBox.add(Box.createHorizontalGlue());
		
		Box verticalBox = Box.createVerticalBox();
		verticalBox.add(Box.createVerticalGlue());
		verticalBox.add(horizontalBox);
		verticalBox.add(Box.createVerticalGlue());
		
		add(verticalBox);
	}

	// getters & setters
	public TTTJLabel getPlayer1Info() {
		return player1Info;
	}

	public void setPlayer1Info(TTTJLabel player1Info) {
		this.player1Info = player1Info;
	}

	public TTTJLabel getPlayer2Info() {
		return player2Info;
	}

	public void setPlayer2Info(TTTJLabel player2Info) {
		this.player2Info = player2Info;
	}

	@Override
	/*
	 * (non-Javadoc)
	 * @see ttt.isatm.view.gui.ChangeListener#playerTurnChange()
	 * called when a move is made by a player
	 */
	public void playerTurnChange() {
		// TODO Auto-generated method stub
		if(turn == 0) {
			turn = 1;
			player1Info.setForeground(basicColor);
			player2Info.setForeground(new Color(255,255,255));
		} else {
			turn = 0;
			player2Info.setForeground(basicColor);
			player1Info.setForeground(new Color(255,255,255));
		}
	}
}
