package ttt.isatm.view.gui;

import java.awt.Color;
import java.awt.Dimension;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;

import ttt.isatm.view.gui.custom.TTTJButton;
import ttt.isatm.view.gui.custom.TTTJLabel;
import ttt.isatm.view.gui.custom.TTTJTextField;

/*
 * last panel show by the game when a winner is determined
 */
public class ScoresJPanel extends JPanel {

	public ScoresJPanel(String winner, String looser) {
		super();
		setBackground(new Color(100,100,100)); 
		
		initWidgets(winner, looser);
	}
	
	private void initWidgets(String winner, String looser) {
		TTTJLabel player1 = new TTTJLabel("WINNER: " + winner);
		TTTJLabel player2 = new TTTJLabel("LOOSER: " + looser);
		player1.setAlignmentX(CENTER_ALIGNMENT);
		player2.setAlignmentX(CENTER_ALIGNMENT);
				
		// set a layout manager
		setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
		
		// add widgets to panel using the BoxLayout
		Box horizontalBox = Box.createHorizontalBox();
		horizontalBox.add(Box.createHorizontalGlue());		
		Box playerBox = Box.createVerticalBox();
		playerBox.setAlignmentX(CENTER_ALIGNMENT);
		playerBox.add(player1);		

		playerBox.add(Box.createRigidArea(new Dimension(5,5)));
		playerBox.add(player2);		

		playerBox.add(Box.createRigidArea(new Dimension(5,5)));
		horizontalBox.add(playerBox);				
		horizontalBox.add(Box.createHorizontalGlue());
		
		Box verticalBox = Box.createVerticalBox();
		verticalBox.add(Box.createVerticalGlue());
		verticalBox.add(horizontalBox);
		verticalBox.add(Box.createVerticalGlue());

		
		add(verticalBox);
	}
}
